#include "mpi.h"

worker( argc, argv )
int argc;
char **argv;
{
    int rank, data, to, from, tag, len, count, np;
    int st_source, st_tag, st_count;
    MPI_HANDLE handle;
    MPI_STATUS status;

    printf( "Entering worker\n" );
    MPI_Init( argc, argv );
    printf( "Initialized\n" );
    MPI_Comm_Rank( (MPI_COMMUNICATOR) MPI_COMM_WORLD, &rank );
    printf( "My rank is %d\n", rank );

    if (rank == 1)
    {
	to     = 0;
	count  = 1;		/* one int, that is */
	tag    = 2000;
	data   = 777;
	printf( "%d about to send\n", rank );
	MPI_Isend( &handle, &data, len, MPI_INT, to, tag, MPI_COMM_WORLD );
	printf( "%d about to wait\n", rank );
	MPI_Wait( handle, &status );
	printf( "%d sent %d\n", rank, data );
    }
    else
    {
	tag   = 2000;
	count = 1;		/* one int */
	from  = MPI_ANY_SOURCE;
	printf( "%d about to receive\n", rank );
	MPI_Irecv( &handle, &data, count, MPI_INT, from, tag, MPI_COMM_WORLD ); 
	printf( "%d about to wait\n", rank );
	MPI_Wait( handle, &status );
/*
	MPI_GET_SOURCE( status, st_source );
	MPI_GET_TAG(    status, st_tag );
	MPI_GET_COUNT(  status, st_count );
*/
	printf( "Status info: source = %d, tag = %d, count = %d\n",
	        st_source, st_tag, st_count );
	printf( "%d received %d\n", rank, data );
    }
    MPI_Finalize();
    printf( "%d done\n", rank );
}
